USE Concurrency2
GO
-- MERGE single rows
MERGE Concurrency2.dbo.TestTable AS T
USING ( VALUES ('A2') ) AS SrcTable (SourceValue)
	 ON SrcTable.SourceValue = T.KeyValue
WHEN NOT MATCHED THEN
	INSERT (KeyValue, KeyDate) VALUES (SourceValue, GETDATE())
WHEN MATCHED THEN
	UPDATE SET KeyDate = GETDATE(),
				SequenceNumber += 1
OUTPUT $action, inserted.* 
;	
select * from Concurrency2.dbo.TestTable;

-- MERGE Multiple rows
MERGE Concurrency2.dbo.TestTable T 
USING ( VALUES ('Test') 
		,('A1')
		,('A2') 
		,('B1')
			) AS S (KV)
	 ON S.KV = T.KeyValue
WHEN NOT MATCHED THEN
	INSERT (KeyValue, KeyDate) VALUES (KV, GETDATE())
WHEN MATCHED THEN
	UPDATE SET KeyDate = GETDATE(),
				SequenceNumber += 1
OUTPUT $action, inserted.* 
;

select * from Concurrency2.dbo.TestTable


