use concurrency2 
go
SET NOCOUNT ON;

DECLARE @TargetDlgHandle UNIQUEIDENTIFIER
DECLARE @ReplyMessage VARCHAR(1000)
DECLARE @ReplyMessageName Sysname 

--Receive message from Initiator
PRINT '=== PROCESSING TargetQueue ===='
;RECEIVE TOP(1)
@TargetDlgHandle = Conversation_Handle
,@ReplyMessage = Message_Body
,@ReplyMessageName = Message_Type_Name
FROM TargetQueue 


IF @TargetDlgHandle IS NOT NULL
  BEGIN 

	PRINT 'Message Type: ' + @ReplyMessageName
	PRINT 'Message: ' + @ReplyMessage

	END CONVERSATION @TargetDlgHandle;
  END
ELSE
	PRINT 'No message found.';


PRINT '=== PROCESSING InitiatorQueue ===='
WAITFOR (	RECEIVE TOP(1)
				@TargetDlgHandle = Conversation_Handle
				,@ReplyMessage = Message_Body
				,@ReplyMessageName = Message_Type_Name
			FROM InitiatorQueue  ), 
TIMEOUT 3000;

IF @TargetDlgHandle IS NOT NULL
  BEGIN 

	PRINT 'Message Type: ' + @ReplyMessageName
	PRINT 'Message: ' + @ReplyMessage

	END CONVERSATION @TargetDlgHandle;
  END
ELSE
	PRINT 'No message found.';


